""" Workflow: PloneFormMailer_workflow
"""

# Copyright (c) 2005 by None
#
# Generator: ArchGenXML Version 1.4 devel 4
#            http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__    = '''unknown <unknown>'''
__docformat__ = 'plaintext'
__version__   = '$ Revision 0.0 $'[11:-2]

from Products.CMFCore.utils import getToolByName
from Products.CMFCore.WorkflowTool import addWorkflowFactory
from Products.DCWorkflow.DCWorkflow import DCWorkflowDefinition
from Products.ExternalMethod.ExternalMethod import ExternalMethod

##code-section create-workflow-module-header #fill in your manual code here
##/code-section create-workflow-module-header


productname = 'PFMWorkflow'

def setupPloneFormMailer_workflow(self, wf):
    """
    PloneFormMailer_workflow Workflow Definition
    """

    wf.setProperties(title='PloneFormMailer_workflow')

    ##code-section create-workflow-setup-method-header #fill in your manual code here
    ##/code-section create-workflow-setup-method-header


    # generation of worklists is not defined yet...
    ### XXX :-(

    for s in ['anonymous send', 'disabled', 'members only send']:
        wf.states.addState(s)

    for t in ['enable anonymous send', 'disable', 'enable members only send']:
        wf.transitions.addTransition(t)

    for v in ['review_history', 'comments', 'time', 'actor', 'action']:
        wf.variables.addVariable(v)

    for p in ['View', 'Send PloneFormMailer Form', 'Access contents information']:
        wf.addManagedPermission(p)

    ## Initial State

    wf.states.setInitialState('members only send')

    ## States initialization

    sdef = wf.states['anonymous send']
    sdef.setProperties(title="""anonymous send""",
                       transitions=['enable members only send', 'disable'])
    sdef.setPermission('View', 0, ['Manager', 'Owner', 'Member', 'Anonymous'])
    sdef.setPermission('Send PloneFormMailer Form', 0, ['Manager', 'Owner', 'Member', 'Anonymous'])
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner', 'Member', 'Anonymous'])

    sdef = wf.states['disabled']
    sdef.setProperties(title="""disabled""",
                       transitions=['enable members only send', 'enable anonymous send'])
    sdef.setPermission('View', 0, ['Manager', 'Owner'])
    sdef.setPermission('Send PloneFormMailer Form', 0, ['Manager', 'Owner'])
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner'])

    sdef = wf.states['members only send']
    sdef.setProperties(title="""members only send""",
                       transitions=['enable anonymous send', 'disable'])
    sdef.setPermission('View', 0, ['Manager', 'Owner', 'Member'])
    sdef.setPermission('Send PloneFormMailer Form', 0, ['Manager', 'Owner', 'Member'])
    sdef.setPermission('Access contents information', 0, ['Manager', 'Owner', 'Member'])

    ## Transitions initialization
        
    tdef = wf.transitions['enable anonymous send']
    tdef.setProperties(title="""enable anonymous send""",
                       new_state_id="""anonymous send""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""enable anonymous send""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Review portal content'},
                       )
        
    tdef = wf.transitions['disable']
    tdef.setProperties(title="""disable""",
                       new_state_id="""disabled""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""disable""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Review portal content'},
                       )
        
    tdef = wf.transitions['enable members only send']
    tdef.setProperties(title="""enable members only send""",
                       new_state_id="""members only send""",
                       trigger_type=1,
                       script_name="""""",
                       after_script_name="""""",
                       actbox_name="""enable members only send""",
                       actbox_url="""""",
                       actbox_category="""workflow""",
                       props={'guard_permissions': 'Review portal content'},
                       )

    ## State Variable
    wf.variables.setStateVar('review_state')

    ## Variables initialization
    vdef = wf.variables['review_history']
    vdef.setProperties(description="""Provides access to workflow history""",
                       default_value="""""",
                       default_expr="""state_change/getHistory""",
                       for_catalog=0,
                       for_status=0,
                       update_always=0,
                       props={'guard_permissions': 'Request review; Review portal content'})

    vdef = wf.variables['comments']
    vdef.setProperties(description="""Comments about the last transition""",
                       default_value="""""",
                       default_expr="""python:state_change.kwargs.get('comment', '')""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['time']
    vdef.setProperties(description="""Time of the last transition""",
                       default_value="""""",
                       default_expr="""state_change/getDateTime""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['actor']
    vdef.setProperties(description="""The ID of the user who performed the last transition""",
                       default_value="""""",
                       default_expr="""user/getId""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    vdef = wf.variables['action']
    vdef.setProperties(description="""The last transition""",
                       default_value="""""",
                       default_expr="""transition/getId|nothing""",
                       for_catalog=0,
                       for_status=1,
                       update_always=1,
                       props=None)

    # XXX Generation of worklists is not implemented yet...
    # in the meantime, you can use the protected code section below to
    # do it manually

    ##code-section create-workflow-setup-method-footer #fill in your manual code here
    ##/code-section create-workflow-setup-method-footer


def createPloneFormMailer_workflow(self, id):
    "..."
    ob = DCWorkflowDefinition(id)
    setupPloneFormMailer_workflow(self, ob)
    return ob

addWorkflowFactory(createPloneFormMailer_workflow,
                   id='PloneFormMailer_workflow',
                   title='PloneFormMailer_workflow')

##code-section create-workflow-module-footer #fill in your manual code here
##/code-section create-workflow-module-footer

