from StringIO import StringIO
from Products.CMFCore.utils import getToolByName

from Products.PloneFormMailer.schema import PFMschema

def migrateToTALESField(portal):
    """1.2 -> 1.3"""
    out = StringIO()
    
    # Build a list of fields that need attention from the schema
    stringFields = []
    linesFields = []
    for field in PFMschema.fields():
        if field.type == 'tales': stringFields.append(field)
        if field.type == 'taleslines': linesFields.append(field)

    # Iterate through all PFM instances.  In 1.2 we used StringField and
    # LinesField, which stored strings and tuples.  From 1.3 on, we use
    # TALESString and TALESLines fields, which store CMFCore.Expressions.
    catalog = getToolByName(portal, 'portal_catalog')
    for brain in catalog(portal_type='PloneFormMailer'):
        instance = brain.getObject()
        schema = instance.Schema()
        migratedFields = []
        def getStoredValue(field):
            return field.getStorage(instance).get(field.getName(), instance)

        for field in stringFields:
            storedValue = getStoredValue(field)
            if isinstance(storedValue, (type(''), type(u''))):
                field.set(instance, storedValue)
                migratedFields.append(field.getName())

        for field in linesFields:
            storedValue = getStoredValue(field)
            if isinstance(storedValue, (type(()), type([]))):
                field.set(instance, storedValue)
                migratedFields.append(field.getName())

        if migratedFields:
            print >> out, "Migrated fields %s of instance at %s." % \
                  (", ".join(migratedFields), brain.getPath())

    return out.getvalue()
                
            
