#------------------------------------------------------------------------------
# Name:         config.py
# Purpose:      some defaults and settings for PloneFormMailer
#
# Author:       Jens Klein <jens@bluedynamics.com>
#
# RCS-ID:       $Id: config.py 24082 2006-05-29 09:11:44Z yenzenz $
# Copyright:    (c) 2004 by BlueDynamics, Klein & Partner KEG, Austria
# Licence:      GNU General Public Licence (GPL) Version 2 or later
#------------------------------------------------------------------------------

# DONT CHANGE THIS FILE! If you need a custom configuration provide a file 
# 'customconfig.py' in the same directory. It is tried to  load at the end of 
# this file and overrides all given in here.

from Products.Archetypes.public import DisplayList

GLOBALS = globals()
ADD_CONTENT_PERMISSION = 'Add PloneFormMailer content'
PROJECTNAME = 'PloneFormMailer'

DEFAULT_MAILTEMPLATE_SUBJECT = \
"""string:PloneFormMailer"""

DEFAULT_MAILTEMPLATE_BODY = \
'''<tal:block i18n:domain="pfm"
           tal:define="form here/form;
                       groups form/get_groups;">
<html>
<body>
<p tal:condition="here/getBodyPre" tal:content="here/getBodyPre" />
<p tal:condition="options/prepend" tal:content="options/prepend" />

<tal:block tal:repeat="group groups">
  <h1 tal:condition="python:group!='Default'" tal:content="group" />
  <table>
    <tbody valign="top">
      <tal:block tal:repeat="field python:form.get_fields_in_group(group)">
        <tr>
          <th i18n:translate="" style="text-align:right; white-space: nowrap; border-bottom: 1px solid #cccccc;" tal:content="field/title" />
          <td>
            <div tal:repeat="line field/mailsplitter">
              <span tal:content="line"/>
            </div>
          </td>
        </tr>
      </tal:block>
    </tbody>
  </table>
</tal:block>

<p tal:condition="options/append" tal:content="options/append" />
<p tal:condition="here/getBodyPost" tal:content="here/getBodyPost" />
<pre tal:content="here/getFooter" />
</body>
</html>
</tal:block>'''

DEFAULT_BEFORE_SCRIPT = """## Script (Python) "DEFAULT_BEFORE_SCRIPT"
##parameters=
##title=Set basic member properties

# recommended behaviour: check whether uf_formid variable is empty.
# If not, do nothing, because user has changed some fields. Previously
# pre-filled fields (not modified by user) are still in REQUEST
if not context.REQUEST.has_key('uf_formid'):
    mtool = context.portal_membership
    if not mtool.isAnonymousUser():
        member = mtool.getAuthenticatedMember()
        # 'email' and 'fullname' are field names defined in Formulator form by default
        context.REQUEST.set('email', member.getProperty('email',''))
        context.REQUEST.set('fullname', member.getProperty('fullname',''))

"""

# LinguaPlone addon?
try:
    from Products.LinguaPlone.public import registerType
except ImportError:
    HAS_LINGUA_PLONE = False
else:
    HAS_LINGUA_PLONE = True

MIME_LIST = DisplayList(
    (('html', 'HTML'),
     ('plain', 'TEXT'),
     ))
     
DEFAULT_MIMEVERSION = '1.0'

FORM_ENCTYPE = 'multipart/form-data'

DEFAULT_UA_DESCRIPTION = \
    'PloneFormMailer    http://plone.org/products/ploneformmailer'

# keep this in SVN and releases!
DEFAULT_FOOTER = \
    '%s\n\n'+\
    'brought to you by BlueDynamics, Klein & Partner KEG, Austria\n'+\
    'http://www.bluedynamics.com                 http://plone.org'
    
# Give people an easy way to override all defaults     
try:
    from customconfig import *
except ImportError:
    pass
