# This script is called on a Formulator field so 'context' is the
# field. It returns either a single string or a list of strings.
value = context.validate(context.REQUEST)

if context.meta_type in ['MultiCheckBoxField', 'MultiListField']:
    # It is a list ['option 1', 'option 3']
    return ' | '.join(value).splitlines()
elif context.meta_type == 'FileField':
    filename = getattr(value, 'filename', value)
    return filename.splitlines()
elif context.meta_type in ['LabelField']:
    # A label doesn't have a value, so just return an emtpy list
    # (as a list is expected)
    return []
else:
    # It is something stringlike or a textfield with '\n's or so.
    # Watch out with str()-ing unicode strings.
    try:
        # The following works for strings and unicode strings.
        result = value.splitlines()
    except:
        # If it borks, translate the integer or so to a string first.
        result = str(value).splitlines()
    return result

